ngram_search_fwdtree.h File Reference

Lexicon tree based Viterbi search. More...

`#include "ngram_search.h"`

Go to the source code of this file.

## Functions

void | ngram_fwdtree_init (ngram_search_t *ngs)
| Initialize N-Gram search for fwdtree decoding.
void | ngram_fwdtree_deinit (ngram_search_t *ngs)
| Release memory associated with fwdtree decoding.
int | ngram_fwdtree_reinit (ngram_search_t *ngs)
| Rebuild search structures for updated language models.
void | ngram_fwdtree_start (ngram_search_t *ngs)
| Start fwdtree decoding for an utterance.
int | ngram_fwdtree_search (ngram_search_t *ngs, int frame_idx)
| Search one frame forward in an utterance.
void | ngram_fwdtree_finish (ngram_search_t *ngs)
| Finish fwdtree decoding for an utterance.

## Detailed Description

Lexicon tree based Viterbi search.

Definition in file ngram_search_fwdtree.h.

## Function Documentation

## ngram_fwdtree_deinit()

void ngram_fwdtree_deinit | ( | ngram_search_t * | ngs | ) |

Release memory associated with fwdtree decoding.

Definition at line 422 of file ngram_search_fwdtree.c.

References ngram_search_s::active_chan_list, and ngram_search_s::max_nonroot_chan.

Referenced by ngram_search_free().

## ngram_fwdtree_finish()

void ngram_fwdtree_finish | ( | ngram_search_t * | ngs | ) |

Finish fwdtree decoding for an utterance.

Definition at line 1499 of file ngram_search_fwdtree.c.

References ngram_search_s::active_chan_list, ngram_search_s::active_word_list, chan_s::hmm, root_chan_s::hmm, ngram_search_s::n_active_chan, ngram_search_s::n_active_word, ngram_search_s::n_root_chan, ngram_search_free_all_rc(), ngram_search_mark_bptable(), ngram_search_s::root_chan, ngram_search_s::st, ngram_search_s::word_active, and ngram_search_s::word_chan.

## ngram_fwdtree_init()

void ngram_fwdtree_init | ( | ngram_search_t * | ngs | ) |

Initialize N-Gram search for fwdtree decoding.

Definition at line 381 of file ngram_search_fwdtree.c.

Referenced by ngram_search_init().

## ngram_fwdtree_reinit()

int ngram_fwdtree_reinit | ( | ngram_search_t * | ngs | ) |

Rebuild search structures for updated language models.

Definition at line 451 of file ngram_search_fwdtree.c.

References ngram_search_s::word_chan.

## ngram_fwdtree_search()

int ngram_fwdtree_search | ( | ngram_search_t * | ngs,
|  | int | frame_idx
| ) |  |

Search one frame forward in an utterance.

Returns
  Number of frames searched (either 0 or 1).

Definition at line 1455 of file ngram_search_fwdtree.c.

References acmod_score(), ngram_search_s::best_score, ngram_search_s::n_frame, ngram_search_mark_bptable(), ngram_search_s::st, WORSE_THAN, and WORST_SCORE.

## ngram_fwdtree_start()

void ngram_fwdtree_start | ( | ngram_search_t * | ngs | ) |

Start fwdtree decoding for an utterance.

Definition at line 471 of file ngram_search_fwdtree.c.

References ngram_search_s::best_score, root_chan_s::hmm, ps_search_s::hyp_str, ngram_search_s::n_1ph_words, ngram_search_s::n_active_chan, ngram_search_s::n_active_word, ngram_search_s::n_frame, ngram_search_s::single_phone_wid, ngram_search_s::st, and ngram_search_s::word_chan.